/**
 * generated by Xtext
 */
package org.eclipse.gemoc.gexpressions.xtext.ui.contentassist;

import com.google.inject.Inject;
import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.gemoc.gexpressions.xtext.services.GExpressionsGrammarAccess;
import org.eclipse.gemoc.gexpressions.xtext.ui.contentassist.AbstractGExpressionsProposalProvider;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ui.editor.contentassist.ContentAssistContext;
import org.eclipse.xtext.ui.editor.contentassist.ICompletionProposalAcceptor;

/**
 * see http://www.eclipse.org/Xtext/documentation.html#contentAssist on how to customize content assistant
 */
@SuppressWarnings("all")
public class GExpressionsProposalProvider extends AbstractGExpressionsProposalProvider {
  @Inject
  private GExpressionsGrammarAccess grammarAccess;
  
  /**
   * Defines what to do with an EClassifier. Basically, either it is an EDataType and it should not allow the "." or it is an EClass and it should allow ".".
   */
  protected void dealWithClassifier(final EClassifier classifier, final Keyword keyword, final ContentAssistContext contentAssistContext, final ICompletionProposalAcceptor acceptor) {
    boolean _matched = false;
    if (classifier instanceof EDataType) {
      _matched=true;
      return;
    }
    super.completeKeyword(keyword, contentAssistContext, acceptor);
  }
  
  /**
   * Default behaviour, should be overriden most of the time
   */
  protected void dealWithEObject(final EObject eo, final Keyword keyword, final ContentAssistContext contentAssistContext, final ICompletionProposalAcceptor acceptor) {
    super.completeKeyword(keyword, contentAssistContext, acceptor);
  }
}
